 
      PARAMETER (NMAX=200)

      CHARACTER DATE*10,TIME*10
      character*120 card
      
      COMMON/MAIN0/ XDIST,Q,RELHT,Z
      COMMON/MAIN1/ SCALE,XC,YC
      COMMON/MAINN/ ITEST,ITRAV,DATE,TIME

      DIMENSION PHI(NMAX),AX(NMAX),AY(NMAX),AC(NMAX)
      DIMENSION C(NMAX),Y(NMAX),X(NMAX)
      DIMENSION WC(NMAX),WY(NMAX),WX(NMAX)
      DIMENSION WWY(NMAX)
      DIMENSION YDSY(NMAX)
     
      open(55,file='PGrassOBSAnalysis.txt')
      write(55,1000)
1000  format(20x,'  DUR     Dist         Q         OMAX         CMAX          CY      &
      &   CMAX/Q       CY/Q             Sy         PHIC',/,&
      &4x,' Exp  YYMMDDHHMM (min)     (m)       (g/s)  (10^-6 g/m^3)(10^-6 g/m^3)&
      &(10^-6 s/m^2)(10^-6 s/m^3)(10^-6 s/m^2)       (m)      (degrees)')
  
      open(20,file='pgarcs.txt',status='old')
      !There are 5 arcs and 68 experiments = 340 individual arcs to process
      read(20,*) card    !Header occurs only once at the top of the file
      IANT = 340 
!
      DO 500 IRUN=1,IANT

      CALL FETCH(N,NFIRST,NLAST,X,Y,C)

!
!       SWAP USER SELECTED VALUES INTO WORKING ARRAYS
!       AND SEARCH AND DEFINE ARCWISE MAX CONCENTRATION.
        OMAX = -9.0
        NUM = NLAST - NFIRST + 1
        DO 10 I = NFIRST, NLAST
        II    = (I-NFIRST) + 1
        WX(II) = X(I)
        WY(II) = Y(I)
        WC(II) = C(I)
        IF( WC(II).GT.OMAX) OMAX = WC(II)
10      CONTINUE
 

      CALL BSTFIT(NUM,OMAX,WC,WX,WY,WWY,PHI,CMAX,SIGY,CDY,RBAR,NOK,PHIC,IERR)
      
      !PHIC is the bearing from the release location to the center of mass along the arc
      !I am reading in the azimuth of receptors shifted by 92 degrees (ie, add 92 degrees)
      !This was done years ago, to avoid the cross-over at 360 (North). In order to
      !list out PHIC is real coordinants, I need to subtract 92 degrees, and also
      !make sure the result is less than 360 degrees
      PHIC = PHIC - 92.0
20    continue
      if( PHIC.gt.360.0 ) then
      PHIC = PHIC - 360.0
      go to 20
      end if      
      
      read(date,1005) imonth,iday,iyear  
1005  format(1x,i2,1x,i2,1x,i2)
      read(time,1010) ihour,imin
1010  format(2i2)
      idur = 10
      !Project Prairie Grass concentration values are in milligrams/m^3
      !by dividing by 1000, I am converting values to micrograms/m^3
      write(55,1020) itest,iyear,imonth,iday,ihour,imin,idur,Rbar,Q,&
                     &OMAX/1000.0,CMAX/1000.0,CDY/1000.0,&
                     &CMAX/(1000.0*Q),CDY/(1000.0*Q),SIGY,PHIC
1020  format(3x,i5,2x,5i2.2,2x,i2,f10.2,3x,f10.2,5(3x,1pe10.4),2x,0pf12.3,f12.3)      

 !
  500 CONTINUE
               
      STOP
      END
      

!
      SUBROUTINE FETCH(N,NFIRST,NLAST,X,Y,C)
!
      PARAMETER (NMAX=200)
      CHARACTER DATE*10,TIME*10
      Character*120 Card
      
      DIMENSION C(NMAX),Y(NMAX),X(NMAX)
      dimension ZiConv(200),Obk(200)
      
      COMMON/MAIN0/ XDIST,Q,RELHT,Z
      COMMON/MAIN1/ SCALE,XC,YC
      COMMON/MAINN/ ITEST,ITRAV,DATE,TIME
     
      READ(20,*) ITEST,ITRAV,DATE,TIME,XDIST
      READ(20,*) N,NFIRST,NLAST,IXYARC,SCALE,XC,YC,Q,RELHT

!
      IF(N.LT.NLAST .OR. NFIRST.LE.0 .OR. NFIRST.GT.NLAST) THEN
      WRITE(55,1000) N,NFIRST,NLAST
 1000 FORMAT(5X,'*** FATAL ERROR ENCOUNTERED ***',&
              &5X,'    NUMBER OF DATA VALUES (N) MUST BE GE. NLAST',&
              &5X,'    AND NLAST MUST BE GREATER THAN NFIRST',/,&
              &5X,'    INPUT VALUES ARE:',&
              &5X,'                 N = ',I3,/,&
              &5X,'            NFIRST = ',I3,/,&
              &5X,'             NLAST = ',I3,//)
!
      STOP
      END IF
!

       DO 10 I = 1,N
       
       READ(20,2000) IX,IY,Conc
2000   format(t18,i3,7x,i3,f10.0)
       A = float(IX)
       R = float(IY)
       C(i) = Conc

       !convert Priject Prairie Grass polar coordinates to cartesian
       CONV = 3.14159/180.0
       IF(A.LE.90.0) THEN
       A = CONV*(90.0-A)
       X(I) = R*COS(A)
       Y(I) = R*SIN(A)
       ELSE IF(A.LE.180.0) THEN
       A = CONV*(A-90.0)
       X(I) = R*COS(A)
       Y(I) = -R*SIN(A)
       ELSE IF(A.LE.270.0) THEN
       A = CONV*(270.0-A)
       X(I) = -R*COS(A)
       Y(I) = -R*SIN(A)
       ELSE
       A = CONV*(A-270.0)
       X(I) = -R*COS(A)
       Y(I) = R*SIN(A)
       END IF
  
   10 CONTINUE
!

      RETURN
      END

      SUBROUTINE BSTFIT(NUM,OMAX,C,X,Y,WY,PHI,CMAX,SY,CDY,RBAR,NOK,PHIC,IERR)

      PARAMETER (NMAX=200)

!     THIS ROUTINE CALCULATES THE BEST-FIT GAUSSIAN PARAMETERS (CMAX,
!     YMAX,AND SIGY) TO TRAVERSE DATA. 

      CHARACTER DATE*10,TIME*10
      INTEGER   FIRST
      
      COMMON/MAINN/ITEST,ITRAV,DATE,TIME
      COMMON/MAIN1/ SCALE,XC,YC


      DIMENSION C(NMAX),X(NMAX),Y(NMAX),WY(NMAX)
      DIMENSION PHI(NMAX),R(NMAX),DPHI(NMAX)
      DIMENSION WC(NMAX)
      DIMENSION obs(nmax),pred(nmax),wwy(nmax)

      DATA PI/3.14159/

!     CMAX=CENTER-LINE CONCENTRATION

      IERR = 0
      CALL ARC(NUM,C,X,Y,PHI,DPHI,NOK,CX,CY,PHIC,RBAR,OMAX,IERR)

      IF( IERR.LT.0 ) THEN
      RETURN
      END IF

!     SET UP CALCULATION ARRAY
      NTEMP = 0
      DO 40 I=1,NUM
      WY(I) = (DPHI(I)/360.0)*2.0*PI*SCALE*RBAR
      R(I)  = ABS(WY(I))
      IF(C(I).GE.0.0) THEN
      NTEMP = NTEMP + 1
      WC(NTEMP) = C(I)
	  wwy(NTEMP)= wy(i)
 
      END IF
40    CONTINUE
      nok = ntemp

!
!     ESTIMATE SY FROM SECOND MOMENT CONSIDERATIONS
      CALL SYSM(NOK,WC,WWY,SY,IERR)
!
!     when key equals zero, then we do not add 'tails' to crosswind
!     integrated concentration.  when using all values you will
!     naturally 'bound' the integral with zero values, hence no need to
!     add 'tails.'

!     trapezoidal area using all reported values ge zero
      key = 0
	  call areatp(NOK,WC,WWY,cytrp1,key)
!
!
!     For now we will use Cytrp1 for estimating Cmax
      cdy = cytrp1
!
!     CALCULATE CMAX GIVEN SYEST AND CDY
      IF( SY.GT.0.0 .AND. CDY.GT.0.0 ) THEN
      CMAX = CDY/( SY*SQRT(2.0*PI) )
      ELSE
      CMAX   = -99.
      IERR   = -2
      END IF

45    CONTINUE

 
      RETURN
      END

      SUBROUTINE ARC(N,C,X,Y,PHI,DPHI,NOK,CX,CY,PHIC,RBAR,OMAX,IERR)

      PARAMETER (NMAX=200)
!
!  1.  Convert X and Y location of receptors into azimuths (phi)
!     in the meteorological sense.  While we do this, define
!     Omax.  Omax is the largest obs conc. value.

!  2.  Compute the center of mass coordinates (CX,CY), assuming
!     we have at least 3 or more values > 0.0 to work with.
!     While we do this, compute rbar

!  3.  Convert CX and CY to azimuth in the meteorological sense.

!  4.  Compute the angular separation of the receptor azimuths
!     (dphi = phi-phic), where dphi is restricted to be within
!     -180 and +180 degrees.

!  5.  Sort the dphi values (carrying along x,y,c) from lowest to
!     highest.

!  6.  Compute phi by adding phic to the sorted dphi values.
!     and while we do this, swap in sorted x,y,c values.


      CHARACTER DATE*10,TIME*10

      COMMON/MAIN1/ SCALE,XC,YC
      COMMON/MAINN/ITEST,ITRAV,DATE,TIME

      DIMENSION X(NMAX),Y(NMAX),C(NMAX),PHI(NMAX),DPHI(NMAX)
      DIMENSION AX(NMAX),AY(NMAX),AC(NMAX)
!
      DATA PI/3.14159/
!
!     INITIAL CHECKS
!
      IF(N.GT.NMAX) THEN
      IERR = -4
      WRITE(55,*) 'Subroutine ARC NUM  = : ',N
      WRITE(55,*) 'Increase NMAX = : ',NMAX
      GO TO 70
      END IF
!
!     DEFINE CONVERSIONS FROM DEGREES TO RADIANS AND
!     RADIANS TO DEGREES
!
      CONV1 = 180.0/PI
      CONV2 = PI/180.0
!
!
!   STEP ONE:  COMPUTE PHI-ARRAY VALUES AND
!              INITIAL FILL OF AX, AY, AC ARRAYS
!
      Omax = -99999.
      DO 10 I=1,N
!
      AX(I) = X(I)
      AY(I) = Y(I)
      AC(I) = C(I)
     if( c(i).gt.Omax ) Omax = c(i)
!
      DX = AX(I) - XC
      DY = AY(I) - YC
      A = ATAN2(DY,DX)
!
!     CONVERT DEGREES AND PLACE IN METEORLOGICAL SENSE
!
      IF(A.GE.0.0) THEN
      PHI(I) = 450.0 - CONV1*A
      ELSE
      PHI(I) =  90.0 - CONV1*A
      END IF
      IF(PHI(I).GT.360.0) PHI(I) = PHI(I) - 360.0
!
   10 CONTINUE
!
!   STEP TWO:  Compute the center of mass, but make sure it
!              makes sense, ie we have at least 3 nonzero
!              concentrations to work with.
!
!     COMPUTE CENTROID COORDINATES (CX,CY)
      CX   = 0
      CY   = 0
      SUMC = 0
      NOK  = 0
      rsum = 0
      DO 20 I=1,N
      IF(C(I).GT.0.0) THEN
      CX = CX + X(I)*C(I)
      CY = CY + Y(I)*C(I)
      r  = sqrt( (x(i)-xc)*(x(i)-xc) + (y(i)-yc)*(y(i)-yc) )
      rsum = rsum + r
      SUMC = SUMC + C(I)
      NOK = NOK + 1
      END IF
20    CONTINUE

!
!     SEE IF WE HAVE ENOUGH VALUES TO WORK
!     WITH.  NOK MUST BE GE. 3 TO CONTINUE.
!
      IF( NOK.LT.3 ) THEN
      IERR = -2
      return
      END IF

      CX = CX/SUMC
      CY = CY/SUMC
      RBAR = rsum/float(nok)

!
!   STEP THREE: DEFINE PHIC
!
!     FIND PHIC POSITION FOR CENTROID
      CONV1 = 180.0/PI

      DX = CX - XC
      DY = CY - YC
      A  = ATAN2(DY,DX)

!     CONVERT TO DEGREES AND PLACE IN METEORLOGICAL SENSE
!
      IF(A.GE.0.0) THEN
      PHIC = 450.0 - CONV1*A
      ELSE
      PHIC =  90.0 - CONV1*A
      END IF
!
!
!  STEP FOUR: COMPUTE DPHI VALUES.
!
      do 30 i=1,n
      dphi(i) = phi(i) - phic

      if( dphi(i).gt.180.0 ) then
      dphi(i) = dphi(i) - 360.0
      end if
      if( dphi(i).lt.-180.0 ) then
      dphi(i) = dphi(i) + 360.0
      end if
      IF(PHIC.GT.360.0) PHIC = PHIC - 360.0
 
30    continue
!
!     Now recenter the center of mass in terms of
!     the dphi values.  And then recompute phic,
!     and then recompute dphic.
!
      sumc  = 0
      scphi = 0
      DO 40 I=1,N
      IF(C(I).GE.0.0) THEN
      scphi = scphi + dphi(i)*C(I)
      SUMC = SUMC + C(I)
      END IF
40    CONTINUE

      cphic = scphi/sumc
      phic  = phic + cphic

      do 50 i=1,n
      dphi(i) = dphi(i) - cphic
50    continue

!     STEP FIVE: SORT DPHI VALUES, LOWEST TO HIGHEST
!
      CALL SORT3(DPHI,AX,AY,AC,N,IERR)
!
      IF(IERR.LT.0) GO TO 70
!
!   STEP SIX:  COMPUTE PHI VALUES
!
      DO 60 I=1,N
      X(I) = AX(I)
      Y(I) = AY(I)
      C(I) = AC(I)
      PHI(I) = DPHI(I) + PHIC
60    CONTINUE

70    RETURN
      END


      SUBROUTINE SORT3(Y,W,X,Z,N,IERR)

      PARAMETER (NMAX=50000)
!
!  SHELL SORT OF N VALUES IN Y-ARRAY FROM
!   LARGEST TO SMALLEST.
!
      INTEGER I,J,J1,GAP,NMG,IERR
      REAL TY,TW,TX,TZ
      REAL Y(NMAX),W(NMAX),X(NMAX),Z(NMAX)
!
      IERR = 0
      
      IF(N.GT.NMAX) THEN
      IERR = -4
      GO TO 999
      END IF
!
      IF(N.GE.1) GO TO 10
      IERR = -5
      GO TO 999
!
   10 IF(N.EQ.1) GO TO 999
!
!  ONE ELEMENT ARRAYS ARE SORTED
!  BY DEFINITION.
!
      GAP = N
   20 GAP = GAP/2
      NMG = N - GAP
      DO 40 J1 = 1,NMG
      I = J1 + GAP
!
!   LOOP J = J1,1,-GAP
!
      J = J1
   30 IF(Y(J).LE.Y(I)) GO TO 40
!
!  SWAP OUT-OF-ORDER PAIRS
!
!       SET IERR TO +2 TO INDICATE
!       REORDERING WAS NEEDED TO
!       SORT ARRAY
!
      IERR = +2
!
      TY = Y(I)
      TW = W(I)
      TX = X(I)
      TZ = Z(I)
!
      Y(I) = Y(J)
      W(I) = W(J)
      X(I) = X(J)
      Z(I) = Z(J)
!
      Y(J) = TY
      W(J) = TW
      X(J) = TX
      Z(J) = TZ
!
!   KEEP OLD POINTER FOR NEXT TIME THROUGH
!
      I = J
      J = J - GAP
      IF(J.GE.1) GO TO 30
   40 CONTINUE
      IF(GAP.GT.1) GO TO 20
  999 RETURN
      END

      SUBROUTINE SORT2(Y,X,N,IERR)

      PARAMETER (NMAX=50000)
!
!   SHELL SORT OF N VALUES IN Y-ARRAY FROM
!   LARGEST TO SMALLEST.
!
      INTEGER I,J,J1,GAP,NMG,IERR
      REAL TY,TX
      REAL Y(NMAX),X(NMAX)
      
      IERR = 0
!
      IF(N.GT.NMAX) THEN
      IERR = -4
      GO TO 999
      END IF
! 
      IF(N.GE.1) GO TO 10
      IERR = -5
      GO TO 999
!
   10 IF(N.EQ.1) GO TO 999
!
!  ONE ELEMENT ARRAYS ARE SORTED
!  BY DEFINITION.
!
      GAP = N
   20 GAP = GAP/2
      NMG = N - GAP
      DO 40 J1 = 1,NMG
      I = J1 + GAP
!
!   LOOP J = J1,1,-GAP
!
      J = J1
   30 IF(Y(J).LE.Y(I)) GO TO 40
!
!  SWAP OUT-OF-ORDER PAIRS
!
!       SET IERR TO +2 TO INDICATE
!       REORDERING WAS NEEDED TO
!       SORT ARRAY
!
      IERR = +2
!
      TY = Y(I)
      TX = X(I)
!
      Y(I) = Y(J)
      X(I) = X(J)
!
      Y(J) = TY
      X(J) = TX
!
!   KEEP OLD POINTER FOR NEXT TIME THROUGH
!
      I = J
      J = J - GAP
      IF(J.GE.1) GO TO 30
   40 CONTINUE
      IF(GAP.GT.1) GO TO 20
  999 RETURN
      END

      SUBROUTINE SYSM(NUM,WC,WR,SYEST,IERR)
!
!     COMPUTE LATERAL DISPERSION FROM SECOND MOMENT
!     OF CONCENTRATION VALUES ABOUT CENTROID POSITION
!
!     WE ASSUME WR IS IN METERS AND
!     WC ARE VALID CONCENTRATION VALUES
!
      PARAMETER (NMAX=200)
      DIMENSION WC(NMAX),WR(NMAX)

      IF( NUM.GE.3 ) THEN
      IERR = 0
      SUMCR2 = 0.0
      SUMC   = 0.0
      DO 10 I = 1,NUM
      SUMCR2 = SUMCR2 + WC(I)*WR(I)*WR(I)
      SUMC   = SUMC + WC(I)
10    CONTINUE
      SYEST = SQRT( SUMCR2/SUMC )
      ELSE
      SYEST = -999.
      IERR = -2
      END IF

      RETURN
      END

      SUBROUTINE SORT1(Y,N,IERR)

      PARAMETER (NMAX=50000)
!
!   SHELL SORT OF N VALUES IN Y-ARRAY FROM
!   LARGEST TO SMALLEST.
!
      INTEGER I,J,J1,GAP,NMG,IERR
      REAL TY
      REAL Y(NMAX)
      
      IERR = 0
!
      IF(N.GT.NMAX) THEN
      IERR = -4
      GO TO 999
      END IF
!
      IF(N.GE.1) GO TO 10
      IERR = -5
      GO TO 999
!
   10 IF(N.EQ.1) GO TO 999
!
!  ONE ELEMENT ARRAYS ARE SORTED
!  BY DEFINITION.
!
      GAP = N
   20 GAP = GAP/2
      NMG = N - GAP
      DO 40 J1 = 1,NMG
      I = J1 + GAP
!
!   LOOP J = J1,1,-GAP
!
      J = J1
   30 IF(Y(J).LE.Y(I)) GO TO 40
!
!  SWAP OUT-OF-ORDER PAIRS
!
!       SET IERR TO +2 TO INDICATE
!       REORDERING WAS NEEDED TO
!       SORT ARRAY
!
      IERR = +2
!
      TY = Y(I)
!
      Y(I) = Y(J)
!
      Y(J) = TY
!
!   KEEP OLD POINTER FOR NEXT TIME THROUGH
!
      I = J
      J = J - GAP
      IF(J.GE.1) GO TO 30
   40 CONTINUE
      IF(GAP.GT.1) GO TO 20
  999 RETURN
      END



      SUBROUTINE AREATP(NUM,C,Y,CYTRAP,key)

      PARAMETER (NMAX=200)
!
!     AREA CALCULATES THE INTEGRAL OF C OVER WY BY
!     TRAPIZOIDAL INTEGRATION. IT IS NOT NECESSARY
!     THAT VALUES OF Y BE EVENLY SPACED.
!
!     NUM=NUMBER OF DATA POINTS TO BE INTEGRATED
!     C concentration divided by q
!     WY = distance from center of mass along arc
!          having radius equal to average distance of
!          receptors from the source (m)
!     CYTRAP=INTEGRAL OF C OVER WY

      DIMENSION C(NMAX),Y(NMAX),wr(nmax),wc(nmax)

!     test number of values
      if( num.gt.nmax ) then
	  write(*,*) 'Subroutine areatp '
	  write(*,*) 'Num = ',num,' nmax = ',nmax
	  stop
	  end if

      itest  = 1
      icount = 0
!     COPY DATA INTO WORK ARRAYS

      if( itest.eq.1 ) then
      DO I=1,NUM
	    if( c(i) .ge. 0 ) then
	    icount = icount + 1
	    WR(I) = Y(I)
        WC(I) = C(I)
        end if
      end do
      end if
      
      if ( itest.ne.1 ) then
      DO I=1,NUM
	   if( c(i) .ge. 0 ) then
       WR(I) = Y(I)
       WC(I) = C(I)
       else
	   WR(I) = Y(I)
       WC(i) = cfill(num,i,c)
       end if
      end do
      end if
   
	  if( itest.eq. 1) then
	  nwork = icount
	  else
	  nwork = num
	  end if
	  
10    CONTINUE

!     SORT DATA IN TERMS OF R, CARRY C-VALUES ALONG
!     NOTE:  SORTED IN TERMS OF R, FROM SMALLEST TO LARGEST
      CALL SORT2(WR,WC,Nwork,IERR)


!     NOW READY TO INTEGRATE OVER WR

      IF( Nwork.LE.2 ) THEN
      CYTRAP = -999.
      GO TO 100
      END IF

      cytrap = 0
      DO 50 I = 2,Nwork
!     NOTE: WR IS SORTED SMALLEST TO LARGEST
      c2 = wc(i)
	  c1 = wc(i-1)
  	  r2 = wr(i)
	  r1 = wr(i-1)
	  cavg = 0.5*(c1+c2)
	  delr = abs(r1-r2 )
	  ctest = cavg*delr
      cytrap = cytrap + ctest
50    CONTINUE
!
!     assume first and last increment are bounded by
!     zero.
!     if (key) is not zero, then
!     add small 'tails' to match this assumption
!
      if(key.ne.0) then
	  delr = abs(wr(2)-wr(1))
	  f1 = 0.5*wc(1)*delr

	  delr = abs(wr(nwork)-wr(nwork-1))
	  f2 = 0.5*wc(nwork)*delr

	  else
	  f1 = 0.0
	  f2 = 0.0
	  end if

      cytrap = cytrap + f1 + f2

100   continue
      RETURN
      END


      function cfill(num,index,c)
!
!     try to interpolate for a missing value
!     within the concentration pattern
!
      parameter (nmax=200)
      dimension c(nmax),y(nmax)
!
      if(num.gt.nmax) then
      write(*,*)'In function cfill, and num>nmax'
      stop
      end if

!     find valid conc. below index position
      if( index.eq.1 ) then
      clow = 0.0
      go to 20
      end if

      ilook = index -1
      if( c(ilook).ge.0.0 ) then
      clow = c(ilook)
      else
      clow = 0.0
      end if

20    continue
!     find valid conc. above index position
      if( index.eq.num ) then
      chigh = 0.0
      go to 30
      end if

      ilook = index + 1
      if( c(ilook).ge.0.0 ) then
      chigh = c(ilook)
      else
      chigh = 0.0
      end if

30    continue
      cfill = 0.5*(clow+chigh)
      return
      end

